︠9daa5ce1-c560-4e2d-a487-551aebcf65fai︠
%html
<div align="right"><span style="font-weight: bold; font-size: 11pt;"> <a href="http://www.lehigh.edu/~zhh210/academia.html">Return to my Sage Notebook list</a></div>

<!--
<p>&nbsp;</p>
<div align="center"><span style="font-weight: bold; font-size: 18pt;">4-Dimensional Polyhedron</span></div>
-->
<div align="left"><span style="font-weight: bold; font-size: 14pt;">Zheng Han <br /> ISE@Lehigh University</span></div>
<p><br /> </p>
<h2>Motivation</h2>
<p>In Linear Optimization(LP), people can solve a given low-dimensional problem by simply scratching the feasible region after which we can immediately figure out the optimal solution(if it exists). Such method only solves LPs with $\leq 3$ variables because human beings are 3-dimensional animals. We have little sense of higher dimensions. However, we know that induction sometimes helps: by starting from lower-dimensional cases, we could infer some properties that a higher-dimensional one should also satisfy thus improve our understanding of all these problems. Furthermore, if we feed more possible lower-dimension cases to our brain, we magically increase our ability to discern those unforseen properties. <br /><br /> This demo aims to take one step toward this direction: let's take a look at the polyhedron as well as the optimal solution of a corresponding LP in 4-dimension. That is, the feasible region, which is a polyhedron, changes (linearly) as time elapses. Consider the LP in the form of: <br /><br /> \[ \begin{eqnarray} \displaystyle{\min_{(x,t)\geq 0} }&amp; c^Tx + c_t t \\ \text{s.t.} &amp; Ax +A_t t \leq b \end{eqnarray} \]
</p>
<h2>Example</h2>
<p>
The feasible region is a polyhedron. For instance, the following example:

\[
\begin{eqnarray}
\displaystyle{\min_{(x,t)\geq 0}  } & -x_1 -6x_2 -13x_3 \\ 
 \begin{align}
 \text{s.t.} \\ \ \\ \ \\ \ \\
 \end{align}
 & 
 \begin{align}
 x_1 + t &\leq 200\\
 x_2 + t &\leq 300 \\
 x_1 +x_2 +x_3 + t &\leq 400 \\
 x_2 +3x_3 + t &\leq 600 
 \end{align}

\end{eqnarray}
\]
We can implement in sage and see how the feasible region and the optimal solution change by modifying $t$.
</p>

︡6cc18a2d-ead3-4880-96c3-5ce325e2d2b7︡{"html": "<div align=\"right\"><span style=\"font-weight: bold; font-size: 11pt;\"> <a href=\"http://www.lehigh.edu/~zhh210/academia.html\">Return to my Sage Notebook list</a></div>\r\n\r\n<!--\r\n<p>&nbsp;</p>\r\n<div align=\"center\"><span style=\"font-weight: bold; font-size: 18pt;\">4-Dimensional Polyhedron</span></div>\r\n-->\r\n<div align=\"left\"><span style=\"font-weight: bold; font-size: 14pt;\">Zheng Han <br /> ISE@Lehigh University</span></div>\r\n<p><br /> </p>\r\n<h2>Motivation</h2>\r\n<p>In Linear Optimization(LP), people can solve a given low-dimensional problem by simply scratching the feasible region after which we can immediately figure out the optimal solution(if it exists). Such method only solves LPs with $\\leq 3$ variables because human beings are 3-dimensional animals. We have little sense of higher dimensions. However, we know that induction sometimes helps: by starting from lower-dimensional cases, we could infer some properties that a higher-dimensional one should also satisfy thus improve our understanding of all these problems. Furthermore, if we feed more possible lower-dimension cases to our brain, we magically increase our ability to discern those unforseen properties. <br /><br /> This demo aims to take one step toward this direction: let's take a look at the polyhedron as well as the optimal solution of a corresponding LP in 4-dimension. That is, the feasible region, which is a polyhedron, changes (linearly) as time elapses. Consider the LP in the form of: <br /><br /> \\[ \\begin{eqnarray} \\displaystyle{\\min_{(x,t)\\geq 0} }&amp; c^Tx + c_t t \\\\ \\text{s.t.} &amp; Ax +A_t t \\leq b \\end{eqnarray} \\]\r\n</p>\r\n<h2>Example</h2>\r\n<p>\r\nThe feasible region is a polyhedron. For instance, the following example:\r\n\r\n\\[\r\n\\begin{eqnarray}\r\n\\displaystyle{\\min_{(x,t)\\geq 0}  } & -x_1 -6x_2 -13x_3 \\\\ \r\n \\begin{align}\r\n \\text{s.t.} \\\\ \\ \\\\ \\ \\\\ \\ \\\\\r\n \\end{align}\r\n & \r\n \\begin{align}\r\n x_1 + t &\\leq 200\\\\\r\n x_2 + t &\\leq 300 \\\\\r\n x_1 +x_2 +x_3 + t &\\leq 400 \\\\\r\n x_2 +3x_3 + t &\\leq 600 \r\n \\end{align}\r\n\r\n\\end{eqnarray}\r\n\\]\r\nWe can implement in sage and see how the feasible region and the optimal solution change by modifying $t$.\r\n</p>"}︡
︠f9d84787-2bec-4c54-bfa5-5e3aea535f71︠
def par(t):
    # Obtain the feasible region: a polyhedron
    tmp = [[200-t,-1,0,0],[300-t,0,-1,0],[400-t,-1,-1,-1],[600-t,0,-1,-3],[0,1,0,0],[0,0,1,0],[0,0,0,1]]
    G = Polyhedron(ieqs = tmp,field = RDF)
    
    # For fixed t, adjust parameters
    c = vector(RDF,[-1,-6,-13])
    A = matrix(RDF,[[1,1,1],[0,1,3],[1,0,0],[0,1,0],[-1,0,0],[0,-1,0],[0,0,-1]])
    b = vector(RDF,[400-t,600-t,200-t,300-t,0,0,0])
    
    # Find the optimal point and attach it to the polyhedron
    sol = linear_program(c,A,b)
    # Plot
    M = G.render_solid(rgbcolor='blue',alpha=.2)+G.render_wireframe(rgbcolor='black')
    M+= point(sol['x'],size=15,rgbcolor='red')
    return M
       
@interact
def _(t=(0,100,1)):
    par(t)
︡28fb81e0-ab22-43b3-9b6d-8f334c3f6d07︡︡
︠1d286ccc-c10c-4217-9e26-b2fb355738e0i︠
%html
<!--
<p>
Sage does not support publishing interacted 3D plots for the moment. But if run within a Sage Notebook, it should work like this:
<img src="http://www.lehigh.edu/~zhh210/picture/4dimension.png"> 
</p>
where we can drag the lightblue button and change $t$ thus change the shape of the polyhedron(feasible region) as well as the optimal solution(shown as the red ball).-->

︡00401cdd-2c13-4d70-a5d4-ebdc38f951cd︡{"html": "<!--\r\n<p>\r\nSage does not support publishing interacted 3D plots for the moment. But if run within a Sage Notebook, it should work like this:\r\n<img src=\"http://www.lehigh.edu/~zhh210/picture/4dimension.png\"> \r\n</p>\r\nwhere we can drag the lightblue button and change $t$ thus change the shape of the polyhedron(feasible region) as well as the optimal solution(shown as the red ball).-->"}︡
︠760c2aa0-ff1f-4778-81cf-672634ed7ae6︠
1+1
︡ec9a9bef-f393-4097-82a5-b32e6bde7d6d︡︡
